#include <avr/io.h>		
#include <avr/interrupt.h>
#include "glcd.c"
#include "utils.h"

int main (void)
{
	DDRC = 0b00000000; 
	PORTC = 0b11111111;

	DDRA = 0b00000000; 

	unsigned char temp1;
	unsigned int temp2;
	unsigned char i;

	glcdInit();
	ADC_init();
	createWelcomeScreen();
	showTheWave();
	timePause(10000000);

	for(;;)
	{
			if (pressedButton == 0)
			{
	        	if (~PINC & (1<<msUp) && (timeDiv <= 1000))
				{
					if(timeDiv == 0)
						timeDiv = 52;
					else
	            		timeDiv += 145;
					pressedButton = 1;
				}
				
				if (~PINC & (1<<msDwn) && (timeDiv >= 52))
				{
					if(timeDiv <= 145)
						timeDiv = 0;
					else
						timeDiv -= 145;
					pressedButton = 1;
				}
			
				if (~PINC & (1<<YposUp) && (Ypos2 <= 60))
	            	Ypos2++;
				
				if (~PINC & (1<<YposDwn) && (Ypos2 >= -60))
					Ypos2--;

				if (~PINC & (1<<freeze))
					while (~PINC & (1<<freeze)); // Snapshot pt display pt a fi urmarita unda
				
			}
			else
			{
				temp1 = PINC;
				if (temp1 == 255)
					pressedButton = 0;
			}
			

	// trigger. 
			dataCounter = 0;
			findZero = 0;
			upLimit = 0;
			dnLimit = 255;


		for (i=99; i>0; i--)
		{
			ADCSRA |= (1 << ADSC); // activez ADC
			loop_until_bit_is_set(ADCSRA, ADIF);		// astept sa fie conversia gata
			temp1 = ADCL;
			temp2 = ADCH;
			timePause(timeDiv); //(7);

			if (upLimit < temp2) // calculez nivelul de tensiune superior al undei de intrare
				upLimit = temp2;
			if (dnLimit > temp2) // calculez nivelul de tensiune inferior al undei de intrare
				dnLimit = temp2;

			if (temp2 > 0)
			{
				temp2 += 5;
				temp2 /= 5;
				temp2 += 2;
			}else temp2 = 2; 
			
			position = temp2 + Ypos2 +5; 
			if (position <= 63 && position >= 0)  // pt ajustarea sus jos a undei
				fillDataLcdBuffer(i,position);
			else
				fillDataLcdBuffer(i,0);

		}
		if(upLimit != dnLimit)
			trigger = (((upLimit - dnLimit)/2)+ dnLimit); // aflu mijlocul undei, pt a fi folosit ca trigger

		createRaster();
		createWave();
		showTheWave();
		
				dataCounter = 0;
				do 
				{
					limitBkup = temp2;

					ADCSRA |= (1 << ADSC); // activez ADC
					loop_until_bit_is_set(ADCSRA, ADIF);
					temp1 = ADCL;
					temp2 = ADCH;

					if(limitBkup == temp2) 
					{
						dataCounter++;
						if(dataCounter >= 500)
							voltageType = DC;
						else
							voltageType = AC;
					}

					if((voltageType == AC) && ((temp2 == trigger) && (limitBkup < temp2)))
						complete = TRUE;
					else
					if((voltageType == DC) && (limitBkup == temp2) && (upLimit != dnLimit))
					{
						dataCounter = 0;
						do
						{
							ADCSRA |= (1 << ADSC); // activez ADC
							loop_until_bit_is_set(ADCSRA, ADIF);
							temp1 = ADCL;
							temp2 = ADCH;
							complete = TRUE;
							dataCounter++;
						}while ((temp2 > trigger) && (dataCounter <1000));
					
						dataCounter = 0;
						do
						{
							ADCSRA |= (1 << ADSC); // activez ADC
							loop_until_bit_is_set(ADCSRA, ADIF);
							temp1 = ADCL;
							temp2 = ADCH;
							complete = TRUE;
							dataCounter++;
						}while ((temp2 < trigger) && (dataCounter <1000));
					}
					else
					if((voltageType == DC) && (limitBkup == temp2))
						complete = TRUE;
					else
						complete = FALSE;
										

				} while(complete == FALSE);

	}	
}



