#include "glcd.h"
#include <util/delay.h>


void glcdInit (void)
{  
  data_port_pins = 0;  // Port DATA Low
  data_port_ddr = 0xff; // Setez portul DATA pe iesire

  ctrl_port = 0;   // Portul CONTROL Low
  ctrl_port_ddr = 0xff; // Setez portul CONTROL pe iesire

  ctrl_port |= (1<<lcdrst);
  ctrl_port |= (1<<lcdcs1);    // Activez CS1 al displayului
        ctrl_port |= (1<<lcdcs2);   // Activez CS2 al displayului
        ctrl_port &= ~(1<<lcdrs);        //Sterg RS  \_
        ctrl_port &= ~(1<<lcdrw);        //Sterg RW  /  Command mode

  _delay_us(42);
  data_port = 0b11000000;   //Afisez linie start = 0 (0-63)
        eStrobe();
 

  _delay_us(42);
        data_port = 0b01000000;   //Setez adresa = 0 (0-63)
        eStrobe();

  _delay_us(42);
        data_port = 0b10111000;   //Setez pagina = 0 (0-7)
        eStrobe();

  _delay_us(42);
        data_port = 0b00111111;   //Displayul e pornit
        eStrobe();

        ctrl_port &= ~(1<<lcdcs1);  // Dezactivez CS1 al displayului
        ctrl_port &= ~(1<<lcdcs2);  // Dezactivez CS2 al displayului

  createRaster();
  showTheWave();
     
}

//====================================================================
//  afisez logo-ul de inceput
//====================================================================
void createWelcomeScreen (void)
{ 
 unsigned int size;
 lcdAddress = 0;
 flashAddress =0;
 const char *data = welcomeScreen;

 for (size = 0; size<1024; size++)
  lcdBuffer[lcdAddress++] = pgm_read_byte(data++);

}
//====================================================================
//copiez 1024 bytes din flash in ram
//====================================================================
void createRaster (void)
{ 
 unsigned int size;
 lcdAddress = 0;
 flashAddress =0;
 const char *data = LcdRaster;

 for (size = 0; size<1024; size++)
  lcdBuffer[lcdAddress++] = pgm_read_byte(data++);

}
//====================================================================
//
//====================================================================
void changeLine (unsigned char lineData)
{
  ctrl_port |= (1<<lcdcs1); // Activez CS1 al displayului
        ctrl_port |= (1<<lcdcs2); // Activez CS2 al displayului
        ctrl_port &= ~(1<<lcdrs);   //Sterg RS. Command mode
  ctrl_port &= ~(1<<lcdrw);   //Sterg RW. Command mode

  lineData += 0b10111000;
        data_port = lineData;  //Setez pagina = 0 (0-7)
        eStrobe();

        data_port = 0b01000000;  //Setez adresa = 0 (0-63)
        eStrobe();
  
  ctrl_port |= (1<<lcdrs); //Setez RS. Data mode

}

//====================================================================
//
//====================================================================

void fillDataLcdBuffer (unsigned char address, unsigned char data)
{
 
 dataLcdBuffer[address] = data;
}

//====================================================================
//
//====================================================================
void showTheWave (void)
{
 for(lcdAddress = 0; lcdAddress < 1024 ;lcdAddress++)
 {

  if (line == 8)
   line = 0;

  if (column == 128)
  {
   column = 0;
   line++;
   if (line == 8)
    line = 0;
   changeLine(line);
  }

  if (column <= 63)
   enable_cs1();

  if (column == 64)
   enable_cs2();

   _delay_us(3);
  ctrl_port |= (1<<lcdrs); // "DATA SEND" mode
  ctrl_port &= ~(1<<lcdrw); 
  data_port = lcdBuffer[lcdAddress];
  eStrobe();

  column++;     // incrementez coloana (max 128).
 }

}

//====================================================================
// Scriu datele pt o unda in bufferul dataLcdBuffer
//====================================================================
void createWave (void)
{
 unsigned char data;
 unsigned char byte;
 unsigned char i = 0;

 for (i=0; i<128; i++)
 {
  byte = 0b10000000;
  lcdAddress = 996; 
  if(i<100)  
  {
   data = dataLcdBuffer[i];
   for (; data>7; data-=8)
    lcdAddress -= 128;
  
   lcdAddress -= i;
  
   for(; data>0; data--)
    byte >>= 1; 
   lcdBuffer[lcdAddress] |= byte;
  }
 }
}

//====================================================================
//
//====================================================================
void enable_cs1 (void)
{
 ctrl_port |= (1<<lcdcs1);   // Activez CS1 al displayului
 ctrl_port &= ~(1<<lcdcs2);   // Dezactivez CS2 al displayului
}

//====================================================================
//
//====================================================================
void enable_cs2 (void)
{
 ctrl_port |= (1<<lcdcs2);   // Activez CS2 al displayului
 ctrl_port &= ~(1<<lcdcs1);   // Dezactivez CS1 al displayului
}

//====================================================================
// astept ca grafica sa nu fie ocupata
//====================================================================
void glcdWait (void)
{
 unsigned char dataIn;
  
 data_port_ddr = 0;   //pun intrarile pe portB
 ctrl_port |= (1<<lcdrw); //Setez pinul r/w pe citire
 ctrl_port &= ~(1<<lcdrs); //Setez registrul select sa comande

 do
 { 
  eStrobe();
  dataIn = data_port_pins; //busy flag pt citire
 }while bit_is_set(dataIn, 7); //astept pana bit7 din dataIn e sters

 data_port_ddr = 0xff;   //pun iesirile pe portB
 ctrl_port &= ~(1<<lcdrw); //Setez pinul r/w pe scriere
 ctrl_port |= (1<<lcdrs); //Setez registrul select pe date


}
//====================================================================
//
//====================================================================
void eStrobe (void)
{
        ctrl_port |= (1<<lcde);   // pinul E high
   _delay_us(3);
        ctrl_port &= ~(1<<lcde);  //pinul E low
   _delay_us(3);
}

//====================================================================
